#include "Lexer.h"

std::string IdentifierStr; // Filled when token == tok_identifier
double NumVal;             // Filled when token == tok_number
int gettok(FILE *fp){
    static int lastChar = ' ';
    static int prevTok = tok_identifier;

    while(isspace(lastChar))
        lastChar = fgetc(fp);
    
    if(isalpha(lastChar)){
        IdentifierStr = lastChar;
        while(isalnum(lastChar = fgetc(fp)))
            IdentifierStr += lastChar;

        if (IdentifierStr == "def"){
            prevTok = tok_def;
            return tok_def;
        }
        if (IdentifierStr == "extern"){
            prevTok = tok_extern;
            return tok_extern;
        }
        if (IdentifierStr == "if"){
            prevTok = tok_if;
            return tok_if;
        }
        if (IdentifierStr == "then"){
            prevTok = tok_then;
            return tok_then;
        }
        if (IdentifierStr == "else"){
            prevTok = tok_else;
            return tok_else;
        }
        if (IdentifierStr == "for"){
            prevTok = tok_for;
            return tok_for;
        }
        if (IdentifierStr == "in"){
            prevTok = tok_in;
            return tok_in;
        }
        prevTok = tok_identifier;
        return tok_identifier;
    }

    if(isdigit(lastChar) ||
            (prevTok != tok_number && (lastChar == '-' || lastChar == '+'))){
        std::string numStr;
        bool dotAppeared = false;
        bool numErr = false;
        do {
            numStr += lastChar;
            lastChar = fgetc(fp);
            if(lastChar == '.'){
                if(dotAppeared)
                    numErr = true;
                else
                    dotAppeared = true;
            }
        } while(isdigit(lastChar) || lastChar == '.');

        if(numErr){
            printf("%s is not a number\n", numStr.c_str());
            exit(1);
        }
        NumVal = strtod(numStr.c_str(), 0);
        prevTok = tok_number;
        return tok_number;
    }

    if(lastChar == '#'){
        do lastChar = fgetc(fp);
        while(lastChar != EOF && lastChar != '\n' && lastChar != '\r');

        if(lastChar != EOF)
            return gettok(fp);
    }

    if(lastChar == EOF)
        return tok_eof;

    prevTok = tok_identifier;
    int thisChar = lastChar;
    lastChar = fgetc(fp);
    return thisChar;
}
